/*************************************
 * File Name:   Adder.v
 * Written by:  Roger Su
 * Last update: December, 2007
 *************************************/
 `include "VerilogCSP.v"
module Adder (left0, left1, right);
    parameter DATA_WIDTH = 8;
    parameter FL = 24;
    parameter BL = 4;
    `USES_CHANNEL
    `INPORT(left0,DATA_WIDTH )
    `INPORT(left1,DATA_WIDTH )
    `OUTPORT(right,DATA_WIDTH )
    reg [DATA_WIDTH -1:0] buffer0;
    reg [DATA_WIDTH -1:0] buffer1;
    reg [DATA_WIDTH -1:0] result;
always
begin
 `RECEIVE(left0,buffer0)
 `RECEIVE(left1,buffer1)
 result = buffer0 + buffer1;      
 #FL;
 `SEND(right, result)     
 #BL;
end
endmodule