/*************************************
 * File Name:   FunctionalTemplate.v
 * Written by:  Roger Su
 * Last update: December, 2007
 *************************************/
 `include "VerilogCSP.v"              //Include VerilogCSP macro definitions
module Adder (left0, left1, right);   //Module and port declarations      
    
    //Parameter list for channel widths, delays, etc.
    parameter DATA_WIDTH = 8;
    parameter FL = 24;
    parameter BL = 4;
    
    //Port instantiations
    `USES_CHANNEL
    `INPORT(left0,DATA_WIDTH)
    `INPORT(left1,DATA_WIDTH)
    `OUTPORT(right,DATA_WIDTH)
    
    //Variable declarations
    reg [DATA_WIDTH -1:0] buffer0;
    reg [DATA_WIDTH -1:0] buffer1;
    reg [DATA_WIDTH -1:0] result;

//Initial block if necessary
initial
begin
end

//Behavioral description of module
//Implements handshaking, operation, and delays
//Refer to VerilogCSP/Verilog documentation for more help
always
begin
 `RECEIVE(left0,buffer0)
 `RECEIVE(left1,buffer1)
 result = buffer0 + buffer1;      
 #FL;
 `SEND(right, result)     
 #BL;
end
endmodule