/*******************************************************************************
 * File Name:		SimpleTokgen.v
 * Written by:		Roger Su
 * Last update:		December, 2007 
 *
 ******************************************************************************/
`include "VerilogCSP.v"
module SimpleTokgen (left, right);
    parameter DATA_WIDTH = 8;
    parameter FL = 2;
    parameter BL = 4;
    parameter INIT_TOKEN = 0;
    `USES_CHANNEL
    `INPORT(left,DATA_WIDTH )
    `OUTPORT(right,DATA_WIDTH )
    reg [DATA_WIDTH -1:0] buffer;
    reg initFlag;

initial
begin
	initFlag = 0;
	 `SEND(right, INIT_TOKEN)
	initFlag = 1;
end
always
begin

 `RECEIVE(left,buffer)     
 #FL;
 wait (initFlag ==1);
 `SEND(right, buffer)     
 #BL;
end
endmodule