/*******************************************************************************
 * File Name:		SpecialTokgen.v
 * Written by:		Arash Saifhashemi
 * Modified by: Roger Su
 * Last update:		December, 2007 
 *	
 ******************************************************************************/
 //This module receives from left, and send to right and down simultaneously
`include "VerilogCSP.v"
module SpecialTokgen(left, right, down);
    parameter DATA_WIDTH = 8;
    parameter FL = 2;
    parameter BL = 4;
    parameter INIT_TOKEN = 0;
    `USES_CHANNEL
    `INPORT(left,DATA_WIDTH )
    `OUTPORT(right,DATA_WIDTH )
    `OUTPORT(down,DATA_WIDTH )
    reg [DATA_WIDTH -1:0] buffer;
    reg initFlag;

initial
begin
	initFlag = 0;
	 `SEND(right, INIT_TOKEN)
	initFlag = 1;
end
always
begin

 `RECEIVE(left,buffer)     
 #FL;
 wait (initFlag ==1);
 fork
	 `SEND(right, buffer)     
	 `SEND(down, buffer)     
 join
 #BL;
end
endmodule