/*******************************************************************************
 * File Name:		Split2.v
 * Written by:		Arash Saifhashemi
 * Modified by: Roger Su
 * Last update:		December, 2007 
 *
 ******************************************************************************/
`include "VerilogCSP.v"
module Split2(left, up, right0, right1);
    parameter DATA_WIDTH = 8;
    parameter SELECT_WIDTH = 8;
    parameter FL = 2;
    parameter BL = 6;
    `USES_CHANNEL
    `INPORT(left,DATA_WIDTH )
    `INPORT(up,SELECT_WIDTH )
    `OUTPORT(right0,DATA_WIDTH )
    `OUTPORT(right1,DATA_WIDTH )
    reg [DATA_WIDTH -1:0] buffer;
    reg [SELECT_WIDTH -1:0] selectVal;
always
begin

 `RECEIVE(up,selectVal)     
 `RECEIVE(left,buffer)
 #FL;
 if (selectVal == 0)
 	`SEND(right0,buffer)
 else
 	`SEND(right1,buffer)

 #BL;
end
endmodule